Subject: Re: [bug#36093] [PATCH 2/2] pack: Add '--entry-point'.

From: Ludovic Courtès <[email-masked]>
Date: Fri, 07 Jun 2019 15:15:39 +0200

Hello,

Ricardo Wurmus <[email-masked]> skribis:

> Ludovic Courtès <[email-masked]> writes:
>
>>> Also, in general, do we conflate "squashfs" and "singularity"?  It has been
>>> that way in guix/scripts/pack.scm's squashfs-image before this patch already
>>> and a few extra files can't hurt, but we could also just provide a
>>> function "singularity-image" or something.
>>
>> Yes, we do conflate Singularity and Squashfs, but I think there’s no
>> other “container tool” that uses Squashfs anyway.
>
> When I originally added the squashfs support to “guix pack” I had
> Singularity in mind, but since it didn’t do anything particular for
> Singularity I named it “squashfs”.
>
> squashfs is used as a format by Snap (which we don’t explicitly support
> yet), but it is also generally useful as a way to share disk images,
> which could for example be used with lxc containers.

Oh, I didn’t know LXC and Snap support squashfs.

>> We could rename it to “singularity”, but it turns out Singularity 3.x
>> has its own image format unimaginatively called SIF, so perhaps we’re
>> better off with the status quo.
>>
>> Thoughts?  Ricardo?
>
> In my opinion, going forward we should not conflate “squashfs” and
> Singularity more and eventually *add* a format handler for Singularity
> 3.x.
>
> But these changes to the “squashfs” format handler look fine to me.
> Let’s deal with Singularity 3.x later.

What about:

  1. Renaming ‘squashfs’ to ‘singularity-squashfs’, and deprecating
     ‘squashfs’.

  2. Eventually, add a ‘sif’ format for Singularity 3’s native image
     format.

  3. Add a ‘snap’ backend, and perhaps an ‘lxc’ backend too.

Thanks,
Ludo’.